<?php
	$object_type = 'help';
	if (isset($_GET['content'])) {
		$object_type = $_GET['content'];
	}
	
	$root = $_SERVER['DOCUMENT_ROOT'].'/manual/';
	
	$root_files = array( '.htaccess', 'phpinfo.php', 'index.php', 'download.php',  'gen_help.php');
	$help_files = array( 'sm4epr.css', 'favicon.ico');
	
	switch($object_type) {
		case 'help': {
			//Archive name
			$archive_file_name='smhelp_'.Date('Ymd').'.zip';
			$all_files = array_merge($help_files,
			get_all_files_folder($root, ''),
			get_all_files_folder($root, 'images')
			);			
			zipFilesAndDownload($all_files, $root, $archive_file_name);
			// echo 'Archive dbase ('.$archive_file_name.')';	
		}; break;
		case 'code' : {
			//Archive name
			$archive_file_name='smcode_'.Date('Ymd').'.zip';
			$all_files = array_merge($help_files, $root_files,
			get_all_files_folder($root, 'scripts'),
			get_all_files_folder($root, 'content'),
			get_all_files_folder($root, 'images')
			);
			zipFilesAndDownload($all_files, $root, $archive_file_name);
		}; break;
		default: {
			header("Content-type: text/plain");
			echo 'Wrong download option.';		
			//			header($_SERVER['SERVER_PROTOCOL'] . ' 500 Internal Server Error', true, 500);
			exit;
		}; break;
	}
	
	//then send the headers to force download the zip file
	header("Content-type: application/zip"); 
	header("Content-Disposition: attachment; filename=$archive_file_name"); 
	header("Pragma: no-cache"); 
	header("Expires: 0"); 
	readfile("$archive_file_name");
	unlink($archive_file_name);
	
	exit;
	
	function zipFilesAndDownload($file_names, $root_path, $archive_file_name)
	{
		$zip = new ZipArchive();
		//create the file and throw the error if unsuccessful
		if ($zip->open($archive_file_name, ZIPARCHIVE::CREATE )!==TRUE) {
			exit("cannot open <$archive_file_name>\n");
		}
		//add each files of $file_name array to archive
		foreach($file_names as $f) {
			$zip->addFile($root_path.$f, $f);
		}
		$zip->close();
	}
	
	function get_all_files_folder($rootPath, $folder)
	{
		$all_files = array();
		$files = new RecursiveIteratorIterator(
		new RecursiveDirectoryIterator($rootPath.$folder),
		RecursiveIteratorIterator::LEAVES_ONLY
		);
		
		foreach ($files as $name => $file) {
			// Skip directories (they would be added automatically)
			if (!$file->isDir()) {
				// Get real and relative path for current file
				$filePath = $file->getRealPath();
				array_push($all_files, substr($filePath, strlen($rootPath)));
			}
		}
		return $all_files;
	}
	
	function get_all_files_folder_mask($rootPath, $folder, $mask)
	{
		
		$Directory = new RecursiveDirectoryIterator($rootPath);
		$Iterator = new RecursiveIteratorIterator($Directory);
		$Regex = new RegexIterator($Iterator, '/^.+\.'.$mask.'$/i', RecursiveRegexIterator::GET_MATCH);
		
		foreach ($Iterator as $name => $file) {
			// Skip directories (they would be added automatically)
			if (!$file->isDir()) {
				// Get real and relative path for current file
				$filePath = $file->getRealPath();
				array_push($all_files, substr($filePath, strlen($rootPath)));
			}
		}
		return $all_files;		
	}
?>	