<?php
	function help_structure()
	{
		global $FOLDER;
		global $PAGE;
		
		$FOLDER = array();
		$FOLDER['root'] = $_SERVER['DOCUMENT_ROOT'];
		$FOLDER['html'] = $FOLDER['root'].'/manual';
		$FOLDER['content']=$FOLDER['root'].'/manual/content/';
		$FOLDER['content2']='content/';
		$FOLDER['scripts']='scripts';
		
		$PAGE = array();
		
		//---- MAIN LOGO SECTION -----------------------------------------------------
		$PAGE['index'] = h('SpecMan4EPR');
		
		//---- GENERAL SECTION -----------------------------------------------------
		$PAGE['general_description'] = h('General description');
		$PAGE['general_concepts'] = h('Concepts','general_description');
		$PAGE['general_client_server'] = h('Client-Server Architecture','general_description');
		$PAGE['general_howtostart'] = h('How to Start','general_description');
		$PAGE['general_history'] = h('History','general_description');
		$PAGE['general_authors'] = h('Credits','general_description');
		
		//---- GRAPHIC USER INTERFACE SECTION -----------------------------------------------------
		$PAGE['gui_map'] = h('GUI Map');
		$PAGE['gui_welcome_screen'] = h('Welcome Screen','gui_map');
		$PAGE['gui_main_menu'] = h('Main Menu and Toolbar','gui_map');
		$PAGE['gui_exp_control_panel'] = h('Experiment Control Panel','gui_map');
		$PAGE['gui_experiment_editor'] = h('Experiment Editor','gui_map');
		
		//---- EXPERIMENT EDITOR -----------------------------------------------------	
		$PAGE['gui_editor_exp'] = h('Experiment Axis Setup','gui_experiment_editor');
		
		//---- ADDITIONAL PANELS -----------------------------------------------------	
		$PAGE['gui_editor_exp_axis'] = h('Experiment Axis Types','gui_editor_exp');
		$PAGE['gui_editor_exp_edlg1'] = h('Acquisition Stream Edit Dialog','gui_editor_exp');
		$PAGE['gui_editor_exp_edlg2'] = h('Variable Edit Dialog','gui_editor_exp');
		$PAGE['gui_editor_exp_edlg3'] = h('Decision Edit Dialog','gui_editor_exp');
		$PAGE['gui_editor_exp_edlg4'] = h('Variable Association Dialog','gui_editor_exp');
		
		//---- END OF EXPERIMENT EDITOR -----------------------------------------------------	
		$PAGE['gui_editor_ppl'] = h('Pulse Script Editor','gui_experiment_editor');
		$PAGE['gui_editor_setup'] = h('Special  Setup','gui_experiment_editor');
		$PAGE['gui_editor_dev'] = h('Direct Device Control','gui_experiment_editor');
		$PAGE['gui_editor_var_pattrn'] = h('Movable Patterns Control','gui_experiment_editor');
		$PAGE['gui_editor_var_pattrn'] = h('Scope Trigger Control','gui_experiment_editor');
		
		//---- ADDITIONAL PANELS -----------------------------------------------------	
		$PAGE['gui_add_panels'] = h('Additional Panels','gui_map');
		$PAGE['gui_editor_queue'] = h('Queue of Jobs','gui_add_panels');
		$PAGE['gui_editor_queue_options'] = h('Job options','gui_add_panels');
		$PAGE['gui_editor_buffer'] = h('Data in Memory (Buffer)','gui_add_panels');
		$PAGE['gui_editor_ini'] = h('Ini window','gui_add_panels');
		$PAGE['gui_editor_log'] = h('Log Window and Status Bar','gui_add_panels');	
		//---- END OF INFORMATION PANELS -----------------------------------------------------	
		
		$PAGE['gui_notes'] = h('Notes','gui_editor_exp');
		$PAGE['gui_viewport'] = h('Data Views','gui_map');
		$PAGE['gui_scope'] = h('Scope Window','gui_map');
		$PAGE['gui_wizards'] = h('Configuration Dialogs','gui_map');
		$PAGE['gui_wizard_devicecfg'] = h('Device Configuration','gui_wizards');        
		$PAGE['gui_wizard_devicecfg1'] = h('Adding Devices','gui_wizard_devicecfg');
		$PAGE['gui_wizard_devicecfg2'] = h('Driver Settings','gui_wizard_devicecfg');
		$PAGE['gui_wizard_devicecfg3'] = h('Property Settings','gui_wizard_devicecfg');
		$PAGE['gui_wizard_devicecfg4'] = h('Pulse Channels','gui_wizard_devicecfg');
		$PAGE['gui_wizard_pulsecfg'] = h('Pulse Configurations','gui_wizards');
		$PAGE['gui_wizard_pulsecfg1'] = h('Command Definition','gui_wizard_pulsecfg');
		$PAGE['gui_wizard_pulsecfg2'] = h('Pattern Definition','gui_wizard_pulsecfg');
		$PAGE['gui_wizard_pulsecfg3'] = h('Pulse Channels','gui_wizard_pulsecfg');
		$PAGE['gui_wizard_interface'] = h('Interface Configuration','gui_wizards');
		$PAGE['gui_wizard_options'] = h('Options','gui_wizards');
		$PAGE['gui_wizard_opt_directory'] = h('Directories','gui_wizard_options');
		$PAGE['gui_wizard_opt_1dview'] = h('1D Viewer Settings','gui_wizard_options');
		$PAGE['gui_wizard_opt_expeditor'] = h('Experiment Editor','gui_wizard_options');
		$PAGE['gui_wizard_opt_scope'] = h('Scope Settings','gui_wizard_options');
		$PAGE['gui_wizard_opt_demon'] = h('Kernel Settings','gui_wizard_options');
		$PAGE['gui_wizard_opt_actions'] = h('Actions','gui_wizard_options');
		$PAGE['gui_wizard_opt_print'] = h('Print Settings','gui_wizard_options');
		$PAGE['gui_wizard_opt_network'] = h('Network Settings','gui_wizard_options');
		$PAGE['gui_wizard_opt_log'] = h('Log Window Settings','gui_wizard_options');
		
		//---- EXPERIMENT -----------------------------------------------------
		$PAGE['gui_elements'] = h('GUI Elements','gui_map');
		$PAGE['gui_spinedit'] = h('Unified Edit Control','gui_elements');
		
		//---- EXPERIMENT -----------------------------------------------------
		$PAGE['exp_main'] = h('Experiment');
		$PAGE['exp_file_format'] = h('File Format','exp_main');
		
		//---- PULSE PROGRAMMING LANGUAGE -----------------------------------------------------
		$PAGE['ppl_overview'] = h('Pulse Programming Language');
		$PAGE['ppl_script'] = h('PPL Script','ppl_overview');
		$PAGE['ppl_language_structure'] = h('Language structure','ppl_overview');
		$PAGE['ppl_type_specifiers'] = h('Type Specifiers','ppl_language_structure');
		$PAGE['ppl_variable_declaration'] = h('Variable declaration','ppl_language_structure');
		$PAGE['ppl_array_declaration'] = h('Array declaration','ppl_language_structure');
		$PAGE['ppl_statements'] = h('Statements','ppl_language_structure');
		$PAGE['ppl_comments'] = h('Comments','ppl_language_structure');
		$PAGE['ppl_whitespace'] = h('Whitespace','ppl_language_structure');
		$PAGE['ppl_keywords'] = h('Keywords','ppl_overview');
		$PAGE['ppl_asm'] = h('asm','ppl_keywords');
		$PAGE['ppl_bool'] = h('bool','ppl_keywords');
		//    $PAGE['ppl_const'] = h('const','ppl_keywords');
		$PAGE['ppl_detect'] = h('detect','ppl_keywords');
		$PAGE['ppl_else'] = h('else','ppl_keywords');
		$PAGE['ppl_end'] = h('end','ppl_keywords');
		$PAGE['ppl_false'] = h('false','ppl_keywords');
		$PAGE['ppl_frequency'] = h('frequency','ppl_keywords');
		$PAGE['ppl_ifelse'] = h('if-else-end','ppl_keywords');
		$PAGE['ppl_int'] = h('int','ppl_keywords');
		$PAGE['ppl_parallel'] = h('parallel-end','ppl_keywords');
		$PAGE['ppl_print'] = h('print','ppl_keywords');
		$PAGE['ppl_phase'] = h('phase','ppl_keywords');
		$PAGE['ppl_reference'] = h('reference','ppl_keywords');
		$PAGE['ppl_repeat'] = h('repeat-end','ppl_keywords');
		$PAGE['ppl_hrepeat'] = h('hrepeat-end','ppl_keywords');
		$PAGE['ppl_real'] = h('real','ppl_keywords');
		$PAGE['ppl_round'] = h('round','ppl_keywords');
		$PAGE['ppl_signal'] = h('signal','ppl_keywords');
		$PAGE['ppl_time'] = h('time','ppl_keywords');
		$PAGE['ppl_timezero'] = h('timezero','ppl_keywords');
		$PAGE['ppl_true'] = h('true','ppl_keywords');
		$PAGE['ppl_wait'] = h('wait','ppl_keywords');
		$PAGE['ppl_command'] = h('Pulse statement','ppl_keywords');
		$PAGE['ppl_pulse_engine'] = h('PPL and Pulse Engine','ppl_overview');	
		$PAGE['pulse_engine_assembler'] = h('Pulse Assembler','ppl_overview');
		$PAGE['ppl_issues'] = h('Known Issues','ppl_overview');
		
		//---- CONSOLE AND SCRIPT LANGUAGE --------------------------------------
		$PAGE['console_overview'] = h('Console commands');
		$PAGE['remote_console_control'] = h('Remote control', 'console_overview');
//		$PAGE['device_overview'] = h('Device','console_overview');

		//---- PLUGINS ----------------------------------------------------------
		$PAGE['plugin_overview'] = h('Plugins');
		$PAGE['plugin_resonator_dip'] = h('Resonator Dip', 'plugin_overview');
		$PAGE['plugin_nist_qband'] = h('NIST Spectrometer Control', 'plugin_overview');

		//---- SPECTROMETER -----------------------------------------------------
		$PAGE['spectrometer_overview'] = h('Spectrometer and Devices');
		$PAGE['device_overview'] = h('Device','spectrometer_overview');
		//---- DEVICE DRIVERS -----------------------------------------------------
		$PAGE['device_list'] = h('List of supported devices','device_overview');
		$PAGE['device_system'] = h('System Device','device_overview');
		$PAGE['device_dummy'] = h('Dummy Device','device_overview');
		$PAGE['device_tcpip'] = h('TCPIP device','device_overview');
		$PAGE['device_easygpib'] = h('EasyGPIB device','device_overview');
		//---- DRIVER PROGRAMMING -----------------------------------------------------
		$PAGE['driver_programming'] = h('Driver programming','spectrometer_overview');
		$PAGE['device_devnotes'] = h('Developers notes','driver_programming');
		$PAGE['device_driver_programming'] = h('Driver programming','driver_programming');
		$PAGE['device_setting_wildcards'] = h('Settings Rules','driver_programming');
		$PAGE['Interface'] = h('','driver_programming');
		
		//---- PULSE ENGINE -----------------------------------------------------
		$PAGE['pulse_engine_overview'] = h('Pulse and AWG Engine');
		$PAGE['pulse_engine_command'] = h('Pulse Command','pulse_engine_overview');
		$PAGE['pulse_engine_service_command'] = h('Service Pulse Command','pulse_engine_overview');
		$PAGE['pulse_engine_pattern'] = h('Pattern','pulse_engine_overview');
		$PAGE['pulse_engine_virtual_channel'] = h('Virtual Channel','pulse_engine_overview');
		$PAGE['pulse_engine_pulse'] = h('Pulse','pulse_engine_overview');
		$PAGE['pulse_engine_event'] = h('Event','pulse_engine_overview');
		$PAGE['pulse_engine_hardware_channel'] = h('Hardware Channel','pulse_engine_overview');
		$PAGE['pulse_upload_pattern'] = h('How to upload pattern','pulse_engine_overview');
		$PAGE['pulse_engine_masterslave'] = h('Master-Slave generators','pulse_engine_overview');
		
		//---- PROGRAM ENGINES SECTION ---------------------------------------------------- 
		$PAGE['program_engines'] = h('Program Engines');
		$PAGE['demon_overview'] = h('Main Engine','program_engines');    
		$PAGE['virtual_machine'] = h('Virtual Machine','program_engines');
		$PAGE['acquisition_daemon'] = h('Acquisition Engine','program_engines');
		
		//---- CONFIGURATION FILES -----------------------------------------------------
		$PAGE['config_files'] = h('Configuration Files');
		$PAGE['config_ini_file'] = h('Interface configuration (INI)','config_files');
		$PAGE['Device Configuration'] = h(' ','config_files');
		$PAGE['config_device'] = h('Device Configuration (CFG)','config_files');
		$PAGE['config_device_declaration'] = h('Device declaration','config_device');
		$PAGE['config_interface_declaration'] = h('Interface  declaration','config_device');
		$PAGE['config_pulse'] = h('Pulse Configuration (CFP)','config_files');
		$PAGE['config_pulse_command'] = h('Command definition','config_pulse');
		$PAGE['config_pulse_pattern'] = h('Pattern definition','config_pulse');
		$PAGE['config_pulse_moveable_pattern'] = h('Movable pattern definition','config_pulse');
		$PAGE['config_pulse_channel'] = h('Channel definition','config_pulse');
		
		//---- OTHER -----------------------------------------------------
		$PAGE['other'] = h('Other');
		$PAGE['other_prefix'] = h('Prefixes','other');

		$PAGE['this_help'] = h('This help');
		
		// Verification of links
		foreach($PAGE as $key=>$value)
		{
			if($value['parent'] === 'root') continue;
			if(array_key_exists($value['parent'], $PAGE)) continue;
			echo('structure: key "'.$value['parent'].'" referenced by "'.$key.'" does not exist'."\n");
			
		}
		
		// Menu level calculation
		foreach($PAGE as $key=>$value)
		{
			if($value['parent'] === 'root')
			$PAGE[$key]['level']=0;
			else
			{
				$parent_level = $PAGE[$value['parent']]['level'];
				$PAGE[$key]['level']=$parent_level + 1;
			}
		}	
	}
	
	function h($name, $pid='root')
	{
		return array('title'=>$name,'parent'=>$pid);
	}
?>